.\" Copyright (c) 1989, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)statfs.2	8.3 (Berkeley) 2/11/94
.\"
.Dd February 11, 1994
.Dt STATFS 2
.Os
.Sh NAME
.Nm statfs
.Nd get file system statistics
.Sh SYNOPSIS
.Fd #include <sys/param.h>
.Fd #include <sys/mount.h>
.Ft int
.Fn statfs "const char *path" "struct statfs *buf"
.Ft int
.Fn fstatfs "int fd" "struct statfs *buf"
.Sh DESCRIPTION
.Fn Statfs
returns information about a mounted file system.
.Fa Path
is the path name of any file within the mounted filesystem.
.Fa Buf
is a pointer to a
.Fn statfs
structure defined as follows:
.Bd -literal
typedef struct fsid { int32_t val[2]; } fsid_t; /* file system id type */

/*
 * file system statistics
 */

#define MFSNAMELEN 16	/* length of fs type name, including null */
#define MNAMELEN   90	/* length of buffer for returned name */

struct statfs {
long	f_spare2;	  /* placeholder */
long	f_bsize;	  /* fundamental file system block size */
long	f_iosize;	  /* optimal transfer block size */
long	f_blocks;	  /* total data blocks in file system */
long	f_bfree;	  /* free blocks in fs */
long	f_bavail;	  /* free blocks avail to non-superuser */
long	f_files;	  /* total file nodes in file system */
long	f_ffree;	  /* free file nodes in fs */
fsid_t	f_fsid;		  /* file system id */
uid_t	f_owner;	  /* user that mounted the filesystem */
int	f_type;		  /* type of filesystem (see below) */
int	f_flags;	  /* copy of mount flags */
long	f_spare[6];	  /* spare for later */
char	f_mntonname[MNAMELEN];	  /* mount point */
char	f_mntfromname[MNAMELEN];  /* mounted filesystem */
};
/*
* File system types.
*/
#define	MOUNT_UFS	1	/* Fast Filesystem */
#define	MOUNT_NFS	2	/* Sun-compatible Network Filesystem */
#define	MOUNT_MFS	3	/* Memory-based Filesystem */
#define	MOUNT_MSDOS	4	/* MS/DOS Filesystem */
#define	MOUNT_LFS	5	/* Log-based Filesystem */
#define	MOUNT_LOFS	6	/* Loopback Filesystem */
#define	MOUNT_FDESC	7	/* File Descriptor Filesystem */
#define	MOUNT_PORTAL	8	/* Portal Filesystem */
#define MOUNT_NULL	9	/* Minimal Filesystem Layer */
#define MOUNT_UMAP	10	/* Uid/Gid Remapping Filesystem */
#define MOUNT_KERNFS	11	/* Kernel Information Filesystem */
#define MOUNT_PROCFS	12	/* /proc Filesystem */
#define MOUNT_AFS	13	/* Andrew Filesystem */
#define MOUNT_CD9660	14	/* ISO9660 (aka CDROM) Filesystem */
#define MOUNT_UNION	15	/* Union (translucent) Filesystem */
#define MOUNT_DEVFS	16	/* existing device Filesystem */
#define MOUNT_EXT2FS	17	/* Linux EXT2FS */
#define MOUNT_TFS	18	/* Netcon Novell filesystem */
#define MOUNT_MAXTYPE	18
.Ed
.Pp
Fields that are undefined for a particular file system are set to -1.
.Fn Fstatfs
returns the same information about an open file referenced by descriptor
.Fa fd .
.Sh RETURN VALUES
Upon successful completion, a value of 0 is returned.
Otherwise, -1 is returned and the global variable
.Va errno
is set to indicate the error.
.Sh ERRORS
.Fn Statfs
fails if one or more of the following are true:
.Bl -tag -width ENAMETOOLONGA
.It Bq Er ENOTDIR
A component of the path prefix of
.Fa Path
is not a directory.
.It Bq Er ENAMETOOLONG
The length of a component of
.Fa path
exceeds 255 characters,
or the length of
.Fa path
exceeds 1023 characters.
.It Bq Er ENOENT
The file referred to by
.Fa path
does not exist.
.It Bq Er EACCES
Search permission is denied for a component of the path prefix of
.Fa path .
.It Bq Er ELOOP
Too many symbolic links were encountered in translating
.Fa path .
.It Bq Er EFAULT
.Fa Buf
or
.Fa path
points to an invalid address.
.It Bq Er EIO
An
.Tn I/O
error occurred while reading from or writing to the file system.
.El
.Pp
.Fn Fstatfs
fails if one or more of the following are true:
.Bl -tag -width ENAMETOOLONGA
.It Bq Er EBADF
.Fa Fd
is not a valid open file descriptor.
.It Bq Er EFAULT
.Fa Buf
points to an invalid address.
.It Bq Er EIO
An
.Tn I/O
error occurred while reading from or writing to the file system.
.El
.Sh HISTORY
The
.Fn statfs
function first appeared in
.Bx 4.4 .
